Index: trunk/NEMOGCM/NEMO/OPA_SRC/TRA/trasbc.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/TRA/trasbc.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/TRA/trasbc.F90	(revision 2528)
@@ -4,7 +4,9 @@
    !! Ocean active tracers:  surface boundary condition
    !!==============================================================================
-   !! History :  8.2  !  98-10  (G. Madec, G. Roullet, M. Imbard)  Original code
-   !!            8.2  !  01-02  (D. Ludicone)  sea ice and free surface
-   !!            8.5  !  02-06  (G. Madec)  F90: Free form and module
+   !! History :  OPA  !  1998-10  (G. Madec, G. Roullet, M. Imbard)  Original code
+   !!            8.2  !  2001-02  (D. Ludicone)  sea ice and free surface
+   !!  NEMO      1.0  !  2002-06  (G. Madec)  F90: Free form and module
+   !!            3.3  !  2010-04  (M. Leclair, G. Madec)  Forcing averaged over 2 time steps
+   !!             -   !  2010-09  (C. Ethe, G. Madec) Merge TRA-TRC
    !!----------------------------------------------------------------------
 
@@ -17,8 +19,13 @@
    USE phycst          ! physical constant
    USE traqsr          ! solar radiation penetration
-   USE trdmod          ! ocean trends 
-   USE trdmod_oce      ! ocean variables trends
+   USE trdmod_oce      ! ocean trends 
+   USE trdtra          ! ocean trends
    USE in_out_manager  ! I/O manager
    USE prtctl          ! Print control
+   USE restart         ! ocean restart
+   USE sbcrnf          ! River runoff  
+   USE sbcmod          ! ln_rnf  
+   USE iom
+   USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
 
    IMPLICIT NONE
@@ -31,7 +38,7 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2005) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -98,11 +105,9 @@
       !!              - save the trend it in ttrd ('key_trdtra')
       !!----------------------------------------------------------------------
-      USE oce, ONLY :   ztrdt => ua   ! use ua as 3D workspace   
-      USE oce, ONLY :   ztrds => va   ! use va as 3D workspace   
-      !!
-      INTEGER, INTENT(in) ::   kt     ! ocean time-step index
-      !!
-      INTEGER  ::   ji, jj                   ! dummy loop indices
-      REAL(wp) ::   zta, zsa, zsrau, zse3t   ! temporary scalars
+      INTEGER, INTENT(in) ::   kt   ! ocean time-step index
+      !!
+      INTEGER  ::   ji, jj, jk, jn           ! dummy loop indices  
+      REAL(wp) ::   zfact, z1_e3t, zsrau, zdep
+      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  ztrdt, ztrds
       !!----------------------------------------------------------------------
 
@@ -114,44 +119,119 @@
 
       zsrau = 1. / rau0             ! initialization
-#if defined key_zco
-      zse3t = 1. / e3t_0(1)
-#endif
-
-      IF( l_trdtra ) THEN           ! Save ta and sa trends
-         ztrdt(:,:,:) = ta(:,:,:) 
-         ztrds(:,:,:) = sa(:,:,:) 
-      ENDIF
-
-      IF( .NOT.ln_traqsr )   qsr(:,:) = 0.e0   ! no solar radiation penetration
-
-      ! Concentration dillution effect on (t,s)
-      DO jj = 2, jpj
-         DO ji = fs_2, fs_jpim1   ! vector opt.
-#if ! defined key_zco
-            zse3t = 1. / fse3t(ji,jj,1)
-#endif
-            IF( lk_vvl) THEN
-               zta = ro0cpr * qns(ji,jj) * zse3t &                   ! temperature : heat flux
-                &    - emp(ji,jj) * zsrau * tn(ji,jj,1)  * zse3t     ! & cooling/heating effet of EMP flux
-               zsa = ( emps(ji,jj) - emp(ji,jj) ) &
-                &                 * zsrau * sn(ji,jj,1)  * zse3t     ! concent./dilut. effect due to sea-ice 
-                                                                     ! melt/formation and (possibly) SSS restoration
-            ELSE
-               zta = ro0cpr * qns(ji,jj) * zse3t     ! temperature : heat flux
-               zsa = emps(ji,jj) * zsrau * sn(ji,jj,1)   * zse3t     ! salinity :  concent./dilut. effect
-            ENDIF
-            ta(ji,jj,1) = ta(ji,jj,1) + zta                          ! add the trend to the general tracer trend
-            sa(ji,jj,1) = sa(ji,jj,1) + zsa
+
+      IF( l_trdtra )   THEN                    !* Save ta and sa trends
+         ALLOCATE( ztrdt(jpi,jpj,jpk) )   ;    ztrdt(:,:,:) = tsa(:,:,:,jp_tem)
+         ALLOCATE( ztrds(jpi,jpj,jpk) )   ;    ztrds(:,:,:) = tsa(:,:,:,jp_sal)
+      ENDIF
+
+!!gm      IF( .NOT.ln_traqsr )   qsr(:,:) = 0.e0   ! no solar radiation penetration
+      IF( .NOT.ln_traqsr ) THEN     ! no solar radiation penetration
+         qns(:,:) = qns(:,:) + qsr(:,:)      ! total heat flux in qns
+         qsr(:,:) = 0.e0                     ! qsr set to zero
+      ENDIF
+
+      !----------------------------------------
+      !        EMP, EMPS and QNS effects
+      !----------------------------------------
+      !                                          Set before sbc tracer content fields
+      !                                          ************************************
+      IF( kt == nit000 ) THEN                      ! Set the forcing field at nit000 - 1
+         !                                         ! -----------------------------------
+         IF( ln_rstart .AND.    &                     ! Restart: read in restart file
+              & iom_varid( numror, 'sbc_hc_b', ldstop = .FALSE. ) > 0 ) THEN
+            IF(lwp) WRITE(numout,*) '          nit000-1 surface tracer content forcing fields red in the restart file'
+            zfact = 0.5e0
+            CALL iom_get( numror, jpdom_autoglo, 'sbc_hc_b', sbc_tsc_b(:,:,jp_tem) )   ! before heat content sbc trend
+            CALL iom_get( numror, jpdom_autoglo, 'sbc_sc_b', sbc_tsc_b(:,:,jp_sal) )   ! before salt content sbc trend
+         ELSE                                         ! No restart or restart not found: Euler forward time stepping
+            zfact = 1.e0
+            sbc_tsc_b(:,:,:) = 0.e0
+         ENDIF
+      ELSE                                         ! Swap of forcing fields
+         !                                         ! ----------------------
+         zfact = 0.5e0
+         sbc_tsc_b(:,:,:) = sbc_tsc(:,:,:)
+      ENDIF
+      !                                          Compute now sbc tracer content fields
+      !                                          *************************************
+
+                                                   ! Concentration dilution effect on (t,s) due to  
+                                                   ! evaporation, precipitation and qns, but not river runoff 
+                                               
+      IF( lk_vvl ) THEN                            ! Variable Volume case
+         DO jj = 2, jpj
+            DO ji = fs_2, fs_jpim1   ! vector opt.
+               ! temperature : heat flux + cooling/heating effet of EMP flux
+               sbc_tsc(ji,jj,jp_tem) = ro0cpr * qns(ji,jj) - zsrau * emp(ji,jj) * tsn(ji,jj,1,jp_tem)
+               ! concent./dilut. effect due to sea-ice melt/formation and (possibly) SSS restoration
+               sbc_tsc(ji,jj,jp_sal) = ( emps(ji,jj) - emp(ji,jj) ) * zsrau * tsn(ji,jj,1,jp_sal)
+            END DO
+         END DO
+      ELSE                                         ! Constant Volume case
+         DO jj = 2, jpj
+            DO ji = fs_2, fs_jpim1   ! vector opt.
+               ! temperature : heat flux
+               sbc_tsc(ji,jj,jp_tem) = ro0cpr * qns(ji,jj)
+               ! salinity    : salt flux + concent./dilut. effect (both in emps)
+               sbc_tsc(ji,jj,jp_sal) = zsrau * emps(ji,jj) * tsn(ji,jj,1,jp_sal)
+            END DO
+         END DO
+      ENDIF
+      ! Concentration dilution effect on (t,s) due to evapouration, precipitation and qns, but not river runoff  
+      DO jn = 1, jpts
+         DO jj = 2, jpj
+            DO ji = fs_2, fs_jpim1   ! vector opt.
+               z1_e3t = zfact / fse3t(ji,jj,1)
+               tsa(ji,jj,1,jn) = tsa(ji,jj,1,jn) + ( sbc_tsc_b(ji,jj,jn) + sbc_tsc(ji,jj,jn) ) * z1_e3t
+            END DO
          END DO
       END DO
-
-      IF( l_trdtra ) THEN      ! save the sbc trends for diagnostic
-         ztrdt(:,:,:) = ta(:,:,:) - ztrdt(:,:,:)
-         ztrds(:,:,:) = sa(:,:,:) - ztrds(:,:,:)
-         CALL trd_mod(ztrdt, ztrds, jptra_trd_nsr, 'TRA', kt)
-      ENDIF
-      !
-      IF(ln_ctl)   CALL prt_ctl( tab3d_1=ta, clinfo1=' sbc  - Ta: ', mask1=tmask,   &
-         &                       tab3d_2=sa, clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
+      !                                          Write in the ocean restart file
+      !                                          *******************************
+      IF( lrst_oce ) THEN
+         IF(lwp) WRITE(numout,*)
+         IF(lwp) WRITE(numout,*) 'sbc : ocean surface tracer content forcing fields written in ocean restart file ',   &
+            &                    'at it= ', kt,' date= ', ndastp
+         IF(lwp) WRITE(numout,*) '~~~~'
+         CALL iom_rstput( kt, nitrst, numrow, 'sbc_hc_b', sbc_tsc(:,:,jp_tem) )
+         CALL iom_rstput( kt, nitrst, numrow, 'sbc_sc_b', sbc_tsc(:,:,jp_sal) )
+      ENDIF
+      !
+      !----------------------------------------
+      !        River Runoff effects
+      !----------------------------------------
+      !
+      zfact = 0.5e0
+
+      ! Effect on (t,s) due to river runoff (dilution effect automatically applied via vertical tracer advection) 
+      IF( ln_rnf ) THEN  
+         DO jj = 2, jpj 
+            DO ji = fs_2, fs_jpim1
+               zdep = 1. / h_rnf(ji,jj)
+               zdep = zfact * zdep  
+               IF ( rnf(ji,jj) .ne. 0.0 ) THEN
+                  DO jk = 1, nk_rnf(ji,jj)
+                                        tsa(ji,jj,jk,jp_tem) = tsa(ji,jj,jk,jp_tem)   &
+                                          &               +  ( rnf_tsc_b(ji,jj,jp_tem) + rnf_tsc(ji,jj,jp_tem) ) * zdep
+                     IF( ln_rnf_sal )   tsa(ji,jj,jk,jp_sal) = tsa(ji,jj,jk,jp_sal)   &
+                                          &               +  ( rnf_tsc_b(ji,jj,jp_sal) + rnf_tsc(ji,jj,jp_sal) ) * zdep 
+                  ENDDO
+               ENDIF
+            ENDDO  
+         ENDDO  
+      ENDIF  
+!!gm  It should be useless
+      CALL lbc_lnk( tsa(:,:,:,jp_tem), 'T', 1. )    ;    CALL lbc_lnk( tsa(:,:,:,jp_sal), 'T', 1. )
+
+      IF( l_trdtra )   THEN                      ! save the horizontal diffusive trends for further diagnostics
+         ztrdt(:,:,:) = tsa(:,:,:,jp_tem) - ztrdt(:,:,:)
+         ztrds(:,:,:) = tsa(:,:,:,jp_sal) - ztrds(:,:,:)
+         CALL trd_tra( kt, 'TRA', jp_tem, jptra_trd_nsr, ztrdt )
+         CALL trd_tra( kt, 'TRA', jp_sal, jptra_trd_nsr, ztrds )
+         DEALLOCATE( ztrdt )      ;     DEALLOCATE( ztrds )
+      ENDIF
+      !
+      IF(ln_ctl)   CALL prt_ctl( tab3d_1=tsa(:,:,:,jp_tem), clinfo1=' sbc  - Ta: ', mask1=tmask,   &
+         &                       tab3d_2=tsa(:,:,:,jp_sal), clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
       !
    END SUBROUTINE tra_sbc
Index: trunk/NEMOGCM/NEMO/OPA_SRC/TRA/traswp.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/TRA/traswp.F90	(revision 2528)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/TRA/traswp.F90	(revision 2528)
@@ -0,0 +1,52 @@
+MODULE traswp
+   !!==============================================================================
+   !!                       ***  MODULE  traswp  ***
+   !! Ocean active tracers: swapping array 
+   !!==============================================================================
+   USE par_oce         ! ocean parameters
+   USE oce             ! ocean dynamics and active tracers
+
+   IMPLICIT NONE
+   PRIVATE
+
+   PUBLIC   tra_swap     ! routine called by step.F90
+   PUBLIC   tra_unswap   ! routine called by step.F90
+
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! $Id$ 
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+
+CONTAINS
+
+   SUBROUTINE tra_swap 
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE tra_swp  ***
+      !!                   
+      !! ** Purpose : Store temperature and salinity aaray into a 4D array 
+      !!
+      !!----------------------------------------------------------------------
+      !
+      tsn(:,:,:,jp_tem) = tn(:,:,:)      ;      tsn(:,:,:,jp_sal) = sn(:,:,:)
+      tsb(:,:,:,jp_tem) = tb(:,:,:)      ;      tsb(:,:,:,jp_sal) = sb(:,:,:)
+      tsa(:,:,:,jp_tem) = ta(:,:,:)      ;      tsa(:,:,:,jp_sal) = sa(:,:,:)
+      !
+   END SUBROUTINE tra_swap
+
+   SUBROUTINE tra_unswap 
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE tra_unswap  ***
+      !!                   
+      !! ** Purpose : Store temperature and salinity aaray into a 4D array 
+      !!
+      !!----------------------------------------------------------------------
+      !
+      tn(:,:,:) = tsn(:,:,:,jp_tem)      ;      sn(:,:,:) = tsn(:,:,:,jp_sal)
+      tb(:,:,:) = tsb(:,:,:,jp_tem)      ;      sb(:,:,:) = tsb(:,:,:,jp_sal)
+      ta(:,:,:) = tsa(:,:,:,jp_tem)      ;      sa(:,:,:) = tsa(:,:,:,jp_sal)
+      !
+   END SUBROUTINE tra_unswap
+
+   !!======================================================================
+END MODULE traswp
Index: trunk/NEMOGCM/NEMO/OPA_SRC/TRA/trazdf.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/TRA/trazdf.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/TRA/trazdf.F90	(revision 2528)
@@ -4,10 +4,11 @@
    !! Ocean active tracers:  vertical component of the tracer mixing trend
    !!==============================================================================
-   !! History :  9.0  !  05-11  (G. Madec)  Original code
+   !! History :  1.0  ! 2005-11  (G. Madec)  Original code
+   !!            3.0  ! 2008-01  (C. Ethe, G. Madec)  merge TRC-TRA
    !!----------------------------------------------------------------------
 
    !!----------------------------------------------------------------------
    !!   tra_zdf      : Update the tracer trend with the vertical diffusion
-   !!       zdf_ctl  : ???
+   !!   tra_zdf_init : initialisation of the computation
    !!----------------------------------------------------------------------
    USE oce             ! ocean dynamics and tracers variables
@@ -21,6 +22,6 @@
 
    USE ldftra_oce      ! ocean active tracers: lateral physics
-   USE trdmod          ! ocean active tracers trends 
-   USE trdmod_oce      ! ocean variables trends
+   USE trdmod_oce      ! ocean active tracers: lateral physics
+   USE trdtra      ! ocean tracers trends 
    USE in_out_manager  ! I/O manager
    USE prtctl          ! Print control
@@ -33,9 +34,9 @@
    PRIVATE
 
-   PUBLIC tra_zdf   !  routine called by step.F90
+   PUBLIC tra_zdf      !  routine called by step.F90
+   PUBLIC tra_zdf_init !  routine called by opa.F90
 
    INTEGER ::   nzdf = 0               ! type vertical diffusion algorithm used
       !                                ! defined from ln_zdf...  namlist logicals)
-
    REAL(wp), DIMENSION(jpk) ::   r2dt  ! vertical profile time-step, = 2 rdttra
       !                                ! except at nit000 (=rdttra) if neuler=0
@@ -46,7 +47,7 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !!  OPA 9.0 , LOCEAN-IPSL (2005) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -60,10 +61,8 @@
       !!---------------------------------------------------------------------
       INTEGER, INTENT( in ) ::   kt      ! ocean time-step index
-
+      !!
       INTEGER  ::   jk                   ! Dummy loop indices
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   ztrdt, ztrds   ! 3D workspace
+      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::   ztrdt, ztrds   ! 3D workspace
       !!---------------------------------------------------------------------
-
-      IF( kt == nit000 )   CALL zdf_ctl          ! initialisation & control of options
 
       !                                          ! set time step
@@ -74,44 +73,41 @@
       ENDIF
 
-      IF( l_trdtra )   THEN                      ! temporary save of ta and sa trends
-         ztrdt(:,:,:) = ta(:,:,:)
-         ztrds(:,:,:) = sa(:,:,:)
+      IF( l_trdtra )   THEN                    !* Save ta and sa trends
+         ALLOCATE( ztrdt(jpi,jpj,jpk) )   ;    ztrdt(:,:,:) = tsa(:,:,:,jp_tem)
+         ALLOCATE( ztrds(jpi,jpj,jpk) )   ;    ztrds(:,:,:) = tsa(:,:,:,jp_sal)
       ENDIF
 
       SELECT CASE ( nzdf )                       ! compute lateral mixing trend and add it to the general trend
+      CASE ( 0 )    ;    CALL tra_zdf_exp( kt, 'TRA', r2dt, nn_zdfexp, tsb, tsa, jpts )  !   explicit scheme 
+      CASE ( 1 )    ;    CALL tra_zdf_imp( kt, 'TRA', r2dt,            tsb, tsa, jpts )  !   implicit scheme 
       CASE ( -1 )                                       ! esopa: test all possibility with control print
-         CALL tra_zdf_exp    ( kt, r2dt )
-         CALL prt_ctl( tab3d_1=ta, clinfo1=' zdf0 - Ta: ', mask1=tmask,               &
-            &          tab3d_2=sa, clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
-         CALL tra_zdf_imp    ( kt, r2dt )
-         CALL prt_ctl( tab3d_1=ta, clinfo1=' zdf1 - Ta: ', mask1=tmask,               &
-            &          tab3d_2=sa, clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
-
-      CASE ( 0 )                                       ! explicit scheme
-         CALL tra_zdf_exp    ( kt, r2dt )
-
-      CASE ( 1 )                                       ! implicit scheme 
-         CALL tra_zdf_imp    ( kt, r2dt )
-
+         CALL tra_zdf_exp( kt, 'TRA', r2dt, nn_zdfexp, tsb, tsa, jpts )
+         CALL prt_ctl( tab3d_1=tsa(:,:,:,jp_tem), clinfo1=' zdf0 - Ta: ', mask1=tmask,               &
+         &             tab3d_2=tsa(:,:,:,jp_sal), clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
+         CALL tra_zdf_imp( kt, 'TRA', r2dt,            tsb, tsa, jpts ) 
+         CALL prt_ctl( tab3d_1=tsa(:,:,:,jp_tem), clinfo1=' zdf1 - Ta: ', mask1=tmask,               &
+         &             tab3d_2=tsa(:,:,:,jp_sal), clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
       END SELECT
 
       IF( l_trdtra )   THEN                      ! save the vertical diffusive trends for further diagnostics
          DO jk = 1, jpkm1
-            ztrdt(:,:,jk) = ( ( ta(:,:,jk) - tb(:,:,jk) ) / r2dt(jk) ) - ztrdt(:,:,jk)
-            ztrds(:,:,jk) = ( ( sa(:,:,jk) - sb(:,:,jk) ) / r2dt(jk) ) - ztrds(:,:,jk)
+            ztrdt(:,:,jk) = ( ( tsa(:,:,jk,jp_tem) - tsb(:,:,jk,jp_tem) ) / r2dt(jk) ) - ztrdt(:,:,jk)
+            ztrds(:,:,jk) = ( ( tsa(:,:,jk,jp_sal) - tsb(:,:,jk,jp_sal) ) / r2dt(jk) ) - ztrds(:,:,jk)
          END DO
-         CALL trd_mod( ztrdt, ztrds, jptra_trd_zdf, 'TRA', kt )
+         CALL trd_tra( kt, 'TRA', jp_tem, jptra_trd_zdf, ztrdt )
+         CALL trd_tra( kt, 'TRA', jp_sal, jptra_trd_zdf, ztrds )
+         DEALLOCATE( ztrdt )      ;     DEALLOCATE( ztrds ) 
       ENDIF
 
       !                                          ! print mean trends (used for debugging)
-      IF(ln_ctl)   CALL prt_ctl( tab3d_1=ta, clinfo1=' zdf  - Ta: ', mask1=tmask,               &
-         &                       tab3d_2=sa, clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
+      IF(ln_ctl)   CALL prt_ctl( tab3d_1=tsa(:,:,:,jp_tem), clinfo1=' zdf  - Ta: ', mask1=tmask,               &
+         &                       tab3d_2=tsa(:,:,:,jp_sal), clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
 
    END SUBROUTINE tra_zdf
 
 
-   SUBROUTINE zdf_ctl
+   SUBROUTINE tra_zdf_init
       !!----------------------------------------------------------------------
-      !!                 ***  ROUTINE zdf_ctl  ***
+      !!                 ***  ROUTINE tra_zdf_init  ***
       !!
       !! ** Purpose :   Choose the vertical mixing scheme
@@ -123,28 +119,20 @@
       !!      the implicit scheme is required.
       !!----------------------------------------------------------------------
-      USE zdftke_old
       USE zdftke
+      USE zdfgls
       USE zdfkpp
       !!----------------------------------------------------------------------
 
-      !  Define the vertical tracer physics scheme
-      ! ==========================================
-
       ! Choice from ln_zdfexp already read in namelist in zdfini module
-      IF( ln_zdfexp ) THEN               ! use explicit scheme
-         nzdf = 0
-      ELSE                               ! use implicit scheme
-         nzdf = 1
+      IF( ln_zdfexp ) THEN   ;   nzdf = 0           ! use explicit scheme
+      ELSE                   ;   nzdf = 1           ! use implicit scheme
       ENDIF
 
       ! Force implicit schemes
-      IF( lk_zdftke_old .OR. lk_zdftke .OR. lk_zdfkpp )   nzdf = 1      ! TKE or KPP physics
-      IF( ln_traldf_iso                               )   nzdf = 1      ! iso-neutral lateral physics
-      IF( ln_traldf_hor .AND. ln_sco                  )   nzdf = 1      ! horizontal lateral physics in s-coordinate
-
-      IF( ln_zdfexp .AND. nzdf == 1 )   THEN
-         CALL ctl_stop( 'tra_zdf : If using the rotation of lateral mixing operator or TKE ', &
-            &           '          or KPP scheme, the implicit scheme is required, set ln_zdfexp = .false.' )
-      ENDIF
+      IF( lk_zdftke .OR. lk_zdfgls .OR. lk_zdfkpp )   nzdf = 1      ! TKE, GLS or KPP physics
+      IF( ln_traldf_iso                           )   nzdf = 1      ! iso-neutral lateral physics
+      IF( ln_traldf_hor .AND. ln_sco              )   nzdf = 1      ! horizontal lateral physics in s-coordinate
+      IF( ln_zdfexp .AND. nzdf == 1 )   CALL ctl_stop( 'tra_zdf : If using the rotation of lateral mixing operator',   &
+            &                         ' TKE or KPP scheme, the implicit scheme is required, set ln_zdfexp = .false.' )
 
       ! Test: esopa
@@ -153,5 +141,5 @@
       IF(lwp) THEN
          WRITE(numout,*)
-         WRITE(numout,*) 'tra:zdf_ctl : vertical tracer physics scheme'
+         WRITE(numout,*) 'tra_zdf_init : vertical tracer physics scheme'
          WRITE(numout,*) '~~~~~~~~~~~'
          IF( nzdf == -1 )   WRITE(numout,*) '              ESOPA test All scheme used'
@@ -159,6 +147,6 @@
          IF( nzdf ==  1 )   WRITE(numout,*) '              Implicit (euler backward) scheme'
       ENDIF
-
-   END SUBROUTINE zdf_ctl
+      !
+   END SUBROUTINE tra_zdf_init
 
    !!==============================================================================
